/* This is the example appearing in the User's Guide. Default values are
   used for the parameters in cg_descent.parm (see listing below).
   The output is the following:

   Termination status: 0
   Convergence tolerance for gradient satisfied
   absolute largest component of gradient: 9.500878e-09
   function value: -6.530787e+02
   cg iterations: 32
   function evaluations: 55
   gradient evaluations: 45 */

#include <math.h>
#include "cg_user.h"

double myvalue
(
    double   *x,
    INT       n
) ;

void mygrad
(
    double    *g ,
    double    *x ,
    INT        n
) ;

int main (void)
{
    double *x, *work ;
    INT i, mydim ;
    int status ;
    cg_stats Stats ;

    mydim = 100 ;

    x = (double *) malloc (mydim*sizeof (double)) ;
    work = (double *) malloc (4*mydim*sizeof (double)) ;

/* starting guess */

    for (i = 0; i < mydim; i++) x [i] = 1. ;
    status = cg_descent (x, mydim, &Stats, NULL, 1.e-8, myvalue, mygrad, work) ;
    free (x) ;
    free (work) ;
}

double myvalue
(
    double   *x,
    INT       n
)
{
    double f, t ;
    INT i ;
    f = 0. ;
    for (i = 0; i < n; i++)
    {
        t = i+1 ;
        t = sqrt (t) ;
        f += exp (x [i]) - t*x [i] ;
    }
    return (f) ;
}

void mygrad
(
    double    *g ,
    double    *x ,
    INT        n
)
{
    double t ;
    INT i ;
    for (i = 0; i < n; i++)
    {
        t = i + 1 ;
        t = sqrt (t) ;
        g [i] = exp (x [i]) -  t ;
    }
    return ;
}
